CREATE SEQUENCE HIBERNATE_SEQUENCE
       START WITH 1
       INCREMENT BY 1;
       
CREATE TABLE UTALLY_EVENT
(
   ID                 BIGINT          NOT NULL,
   CREATION_TIME      TIMESTAMP       NOT NULL,
   DESCRIPTION        VARCHAR(2048),
   ENABLED            BOOLEAN         NOT NULL,
   MODIFICATION_TIME  TIMESTAMP       NOT NULL,
   PLAYERS_FEE        INTEGER         NOT NULL,
   EVENT_TITLE        VARCHAR(64)     NOT NULL
);

CREATE TABLE UTALLY_EVENT_LOCATION_MAPPING
(
   LOCATION_ID  BIGINT   NOT NULL,
   EVENT_ID     BIGINT   NOT NULL
);

CREATE TABLE UTALLY_EVENT_TEAM_MAPPING
(
   TEAM_ID   BIGINT   NOT NULL,
   EVENT_ID  BIGINT   NOT NULL
);

CREATE TABLE UTALLY_LOCATION
(
   ID                 BIGINT          NOT NULL,
   CREATION_TIME      TIMESTAMP       NOT NULL,
   DESCRIPTION        VARCHAR(2048),
   ENABLED            BOOLEAN         NOT NULL,
   MODIFICATION_TIME  TIMESTAMP       NOT NULL,
   LOCATION_NAME      VARCHAR(64)     NOT NULL
);

CREATE TABLE UTALLY_LOCATION_PRODUCT_MAPPING
(
   LOCATION_ID  BIGINT   NOT NULL,
   PRODUCT_ID   BIGINT   NOT NULL
);

CREATE TABLE UTALLY_LOG_ENTRY
(
   ID           BIGINT          NOT NULL,
   LOG_TIME     TIMESTAMP       NOT NULL,
   EVENT_TITLE  VARCHAR(2048)   NOT NULL,
   SEVERITY     VARCHAR(255)    NOT NULL
);

CREATE TABLE UTALLY_PLAYER
(
   ID                    BIGINT        NOT NULL,
   COMMENT               VARCHAR(64)   NOT NULL,
   CREATION_TIME         TIMESTAMP     NOT NULL,
   ENABLED               BOOLEAN       NOT NULL,
   MODIFICATION_TIME     TIMESTAMP     NOT NULL,
   PLAYER_NAME           VARCHAR(64)   NOT NULL,
   PAID                  BOOLEAN       NOT NULL,
   PAID_PLAYERS_FEE      INTEGER       NOT NULL,
   PAYED_AT              TIMESTAMP,
   PAID_WITH_PLAYERSFEE  BOOLEAN       NOT NULL,
   EVENT_ID              BIGINT,
   TEAM_ID               BIGINT
);

CREATE TABLE UTALLY_PREFERENCES
(
   PLAYER_ID  BIGINT          NOT NULL,
   VALUE      VARCHAR(1024),
   KEY        VARCHAR(255)    NOT NULL
);

CREATE TABLE UTALLY_PRODUCT
(
   ID                 BIGINT          NOT NULL,
   CATEGORY           VARCHAR(255)    NOT NULL,
   CREATION_TIME      TIMESTAMP       NOT NULL,
   DESCRIPTION        VARCHAR(2048),
   DISPLAY_STATISTIC  BOOLEAN         NOT NULL,
   ENABLED            BOOLEAN         NOT NULL,
   IMAGE              VARCHAR(128)    NOT NULL,
   MODIFICATION_TIME  TIMESTAMP       NOT NULL,
   NAME               VARCHAR(64)     NOT NULL,
   PRICE              INTEGER         NOT NULL
);

CREATE TABLE UTALLY_SETTING
(
   SETTING_KEY    VARCHAR(255)    NOT NULL,
   SETTING_VALUE  VARCHAR(1024)
);

CREATE TABLE UTALLY_TALLY
(
   ID           BIGINT      NOT NULL,
   CANCELLED    BOOLEAN     NOT NULL,
   TIME         TIMESTAMP   NOT NULL,
   LOCATION_ID  BIGINT,
   PLAYER_ID    BIGINT,
   PRODUCT_ID   BIGINT
);

CREATE TABLE UTALLY_TEAM
(
   ID                 BIGINT          NOT NULL,
   CITY               VARCHAR(64)     NOT NULL,
   CREATION_TIME      TIMESTAMP       NOT NULL,
   DESCRIPTION        VARCHAR(2048),
   ENABLED            BOOLEAN         NOT NULL,
   FULL_NAME          VARCHAR(128)    NOT NULL,
   MODIFICATION_TIME  TIMESTAMP       NOT NULL,
   SHORT_NAME         VARCHAR(64)     NOT NULL
);

CREATE TABLE UTALLY_TIMESLOT
(
   ID                 BIGINT          NOT NULL,
   CREATION_TIME      TIMESTAMP       NOT NULL,
   DESCRIPTION        VARCHAR(2048),
   ENABLED            BOOLEAN         NOT NULL,
   SLOT_END           TIMESTAMP       NOT NULL,
   SLOT_LABEL         VARCHAR(64)     NOT NULL,
   MODIFICATION_TIME  TIMESTAMP       NOT NULL,
   SLOT_START         TIMESTAMP       NOT NULL,
   EVENT_ID           BIGINT
);

ALTER TABLE UTALLY_EVENT
   ADD PRIMARY KEY (ID);
   
ALTER TABLE UTALLY_LOCATION
   ADD PRIMARY KEY (ID);
   
ALTER TABLE UTALLY_LOG_ENTRY
   ADD PRIMARY KEY (ID);
   
ALTER TABLE UTALLY_PLAYER
   ADD PRIMARY KEY (ID);

ALTER TABLE UTALLY_PRODUCT
   ADD PRIMARY KEY (ID);

ALTER TABLE UTALLY_SETTING
   ADD PRIMARY KEY (SETTING_KEY);

ALTER TABLE UTALLY_TALLY
   ADD PRIMARY KEY (ID);

ALTER TABLE UTALLY_TEAM
   ADD PRIMARY KEY (ID);

ALTER TABLE UTALLY_TIMESLOT
   ADD PRIMARY KEY (ID);
  
ALTER TABLE UTALLY_PREFERENCES
   ADD PRIMARY KEY (PLAYER_ID, KEY);

ALTER TABLE UTALLY_EVENT_LOCATION_MAPPING
   ADD PRIMARY KEY (LOCATION_ID, EVENT_ID);
  
ALTER TABLE UTALLY_EVENT_TEAM_MAPPING
   ADD PRIMARY KEY (TEAM_ID, EVENT_ID);
 
ALTER TABLE UTALLY_LOCATION_PRODUCT_MAPPING
   ADD PRIMARY KEY (LOCATION_ID, PRODUCT_ID);

ALTER TABLE UTALLY_EVENT_LOCATION_MAPPING
  ADD CONSTRAINT FKE4PHA99D90Y2WDNFSJJCS7FUK FOREIGN KEY (LOCATION_ID)
  REFERENCES UTALLY_EVENT (ID)
  ON UPDATE NO ACTION
  ON DELETE NO ACTION;

ALTER TABLE UTALLY_EVENT_LOCATION_MAPPING
  ADD CONSTRAINT FKRRNSUDD4AVIO1TPCGMG0RDGE9 FOREIGN KEY (EVENT_ID)
  REFERENCES UTALLY_LOCATION (ID)
  ON UPDATE NO ACTION
  ON DELETE NO ACTION;

ALTER TABLE UTALLY_EVENT_TEAM_MAPPING
  ADD CONSTRAINT FK4S30HMH00W5YHVJB5C6R3LPH7 FOREIGN KEY (TEAM_ID)
  REFERENCES UTALLY_EVENT (ID)
  ON UPDATE NO ACTION
  ON DELETE NO ACTION;

ALTER TABLE UTALLY_EVENT_TEAM_MAPPING
  ADD CONSTRAINT FKMV8GC3C1OHM01VMM1J7PDD4TV FOREIGN KEY (EVENT_ID)
  REFERENCES UTALLY_TEAM (ID)
  ON UPDATE NO ACTION
  ON DELETE NO ACTION;

ALTER TABLE UTALLY_LOCATION_PRODUCT_MAPPING
  ADD CONSTRAINT FKN50R7DDBFHDJ0W25GL3JKDJWL FOREIGN KEY (LOCATION_ID)
  REFERENCES UTALLY_LOCATION (ID)
  ON UPDATE NO ACTION
  ON DELETE NO ACTION;

ALTER TABLE UTALLY_LOCATION_PRODUCT_MAPPING
  ADD CONSTRAINT FK69CC7899BRC3QFLN8PLNHUMA7 FOREIGN KEY (PRODUCT_ID)
  REFERENCES UTALLY_PRODUCT (ID)
  ON UPDATE NO ACTION
  ON DELETE NO ACTION;

ALTER TABLE UTALLY_PLAYER
  ADD CONSTRAINT FKBM66IR5FTWFS8Q3MDM6EN7EVA FOREIGN KEY (EVENT_ID)
  REFERENCES UTALLY_EVENT (ID)
  ON UPDATE NO ACTION
  ON DELETE NO ACTION;

ALTER TABLE UTALLY_PLAYER
  ADD CONSTRAINT FKSST7S5ULUD6MCGWIARLT6E0IG FOREIGN KEY (TEAM_ID)
  REFERENCES UTALLY_TEAM (ID)
  ON UPDATE NO ACTION
  ON DELETE NO ACTION;

ALTER TABLE UTALLY_PREFERENCES
  ADD CONSTRAINT FKJ6IARLRNJHIXFJE2EMITLT2YY FOREIGN KEY (PLAYER_ID)
  REFERENCES UTALLY_PLAYER (ID)
  ON UPDATE NO ACTION
  ON DELETE NO ACTION;

ALTER TABLE UTALLY_TALLY
  ADD CONSTRAINT FKT1JNOFVGM7J06H6VI9NETVVU9 FOREIGN KEY (LOCATION_ID)
  REFERENCES UTALLY_LOCATION (ID)
  ON UPDATE NO ACTION
  ON DELETE NO ACTION;

ALTER TABLE UTALLY_TALLY
  ADD CONSTRAINT FK2G0K9DY4X3CC8HYLK5PYDV4XP FOREIGN KEY (PLAYER_ID)
  REFERENCES UTALLY_PLAYER (ID)
  ON UPDATE NO ACTION
  ON DELETE NO ACTION;

ALTER TABLE UTALLY_TALLY
  ADD CONSTRAINT FK5WRLMLIDW0XK8MR4DJPLFDT6V FOREIGN KEY (PRODUCT_ID)
  REFERENCES UTALLY_PRODUCT (ID)
  ON UPDATE NO ACTION
  ON DELETE NO ACTION;

ALTER TABLE UTALLY_TIMESLOT
  ADD CONSTRAINT FKK4YVL487I72J1N46QH8X2NVAK FOREIGN KEY (EVENT_ID)
  REFERENCES UTALLY_EVENT (ID)
  ON UPDATE NO ACTION
  ON DELETE NO ACTION;

CREATE INDEX SYS_IDX_FKRRNSUDD4AVIO1TPCGMG0RDGE9_10236
   ON UTALLY_EVENT_LOCATION_MAPPING (EVENT_ID ASC);

CREATE INDEX SYS_IDX_FKE4PHA99D90Y2WDNFSJJCS7FUK_10240
   ON UTALLY_EVENT_LOCATION_MAPPING (LOCATION_ID ASC);

CREATE INDEX SYS_IDX_FK4S30HMH00W5YHVJB5C6R3LPH7_10248
   ON UTALLY_EVENT_TEAM_MAPPING (TEAM_ID ASC);

CREATE INDEX SYS_IDX_FKMV8GC3C1OHM01VMM1J7PDD4TV_10244
   ON UTALLY_EVENT_TEAM_MAPPING (EVENT_ID ASC);

CREATE INDEX SYS_IDX_FK69CC7899BRC3QFLN8PLNHUMA7_10252
   ON UTALLY_LOCATION_PRODUCT_MAPPING (PRODUCT_ID ASC);

CREATE INDEX SYS_IDX_FKN50R7DDBFHDJ0W25GL3JKDJWL_10256
   ON UTALLY_LOCATION_PRODUCT_MAPPING (LOCATION_ID ASC);

CREATE INDEX SYS_IDX_FKBM66IR5FTWFS8Q3MDM6EN7EVA_10260
   ON UTALLY_PLAYER (EVENT_ID ASC);

CREATE INDEX SYS_IDX_FKSST7S5ULUD6MCGWIARLT6E0IG_10271
   ON UTALLY_PLAYER (TEAM_ID ASC);

CREATE INDEX SYS_IDX_FKJ6IARLRNJHIXFJE2EMITLT2YY_10282
   ON UTALLY_PREFERENCES (PLAYER_ID ASC);

CREATE INDEX SYS_IDX_FKK4YVL487I72J1N46QH8X2NVAK_10301
   ON UTALLY_TIMESLOT (EVENT_ID ASC);

CREATE INDEX SYS_IDX_FK2G0K9DY4X3CC8HYLK5PYDV4XP_10291
   ON UTALLY_TALLY (PLAYER_ID ASC);

CREATE INDEX SYS_IDX_FK5WRLMLIDW0XK8MR4DJPLFDT6V_10296
   ON UTALLY_TALLY (PRODUCT_ID ASC);

CREATE INDEX SYS_IDX_FKT1JNOFVGM7J06H6VI9NETVVU9_10286
   ON UTALLY_TALLY (LOCATION_ID ASC);
